#pragma GCC optimize "O3"
#include<bits/stdc++.h>
using namespace std;
using LL=long long;
#define FOR(i,l,r) for(int i=(l);i<=(r);++i)
#define REP(i,n) FOR(i,0,(n)-1)
#define ssize(x) int(x.size())
#ifdef DEBUG
auto&operator<<(auto&o,pair<auto,auto>p){return o<<"("<<p.first<<", "<<p.second<<")";}
auto operator<<(auto&o,auto x)->decltype(x.end(),o){o<<"{";int i=0;for(auto e:x)o<<","+!i++<<e;return o<<"}";}
#define debug(x...) cerr<<"["#x"]: ",[](auto...$){((cerr<<$<<"; "),...)<<endl;}(x)
#else
#define debug(...) {}
#endif

template<typename T>
void print(T x) {
	cout << x;
	cerr << x;
	cout.flush();
	cerr.flush();
}

constexpr int max_n = 21 * 21;
vector<int> get_max_clique(vector<bitset<max_n>> e) {
	double limit = 0.025, pk = 0;
	vector<pair<int, int>> V;
	vector<vector<int>> C(ssize(e) + 1);
	vector<int> qmax, q, S(ssize(C)), old(S);
	REP(i, ssize(e)) V.emplace_back(0, i);
	auto init = [&](vector<pair<int, int>>& r) {
		for (auto& v : r) for(auto j : r) v.first += e[v.second][j.second];
		sort(r.rbegin(), r.rend());
		int mxD = r[0].first;
		REP(i, ssize(r)) r[i].first = min(i, mxD) + 1;
	};
	function<void (vector<pair<int, int>>&, int)> expand = [&](vector<pair<int, int>>& R, int lev) {
		S[lev] += S[lev - 1] - old[lev];
		old[lev] = S[lev - 1];
		while (ssize(R)) {
			if (ssize(q) + R.back().first <= ssize(qmax))
				return;
			q.emplace_back(R.back().second);
			vector<pair<int, int>> T;
			for (auto [_, v] : R) if (e[R.back().second][v])
				T.emplace_back(0, v);
			if (ssize(T)) {
				if (S[lev]++ / ++pk < limit) init(T);
				int j = 0, mxk = 1, mnk = max(ssize(qmax) - ssize(q) + 1, 1);
				C[1] = C[2] = {};
				for (auto [_, v] : T) {
					int k = 1;
					while (any_of(C[k].begin(), C[k].end(), [&](int i) { return e[v][i]; })) k++;
					if (k > mxk) C[(mxk = k) + 1] = {};
					if (k < mnk) T[j++].second = v;
					C[k].emplace_back(v);
				}
				if (j > 0) T[j - 1].first = 0;
				FOR(k, mnk, mxk) for (int i : C[k]) T[j++] = {k, i};
				expand(T, lev + 1);
			} else if (ssize(q) > ssize(qmax)) qmax = q;
			q.pop_back(), R.pop_back();
		}
	};
	init(V), expand(V, 1); return qmax;
}

int main() {
	cin.tie(0)->sync_with_stdio(0);

	auto solve = [&](int N, vector<pair<int, int>> valid, vector<bitset<max_n>> graph) {
		auto start = chrono::system_clock::now();

		auto ans = get_max_clique(graph);

		auto end = chrono::system_clock::now();
		int ms = chrono::duration_cast<chrono::milliseconds>(end - start).count();
		if (ms < 200) {
			return;
		}
		int cnt = 0;
		REP(i, N)
			REP(j, i)
				cnt += graph[i][j];

		print(N);
		print(' ');
		print(cnt);
		print('\n');
		print(ssize(ans));
		print('\n');
		for (auto id : ans) {
			auto [x, y] = valid[id];
			print(x);
			print(' ');
			print(y);
			print('\n');
		}
	};

	FOR(N, 1, 20) {
		vector<pair<int, int>> valid;
		const double eps = 1e-9;
		REP(i, N + 1) {
			REP(j, N + 1) {
				if (min(i, j) - r >= -eps and max(i, j) + r <= N + eps)
					valid.emplace_back(i, j);
			}
		}
		n = ssize(valid);

		vector<tuple<int, int, int>> edges;

		vector<bitset<max_n>> graph(n);
		auto sq = [&](int x) {
			return x * x;
		};
		REP(i, n) {
			auto [xa, ya] = valid[i];
			REP(j, i) {
				auto [xb, yb] = valid[j];
				auto val = sq(xa - xb) + sq(ya - yb);
				edges.emplace_back(val, i, j);
			}
		}
		sort(edges.rbegin(), edges.rend());

		solve(N, valid, graph);
		REP(i, ssize(edges)) {
			int x = i + 1;
			while (x < ssize(edges) and get<0>(edges[x]) == get<0>(edges[i]))
				++x;
			FOR(j, i, x - 1) {
				auto [_, a, b] = edges[j];
				graph[a][b] = graph[b][a] = 1;
			}
			solve(N, valid, graph);
			i = x - 1;
		}
		cerr << "DONE: " << n << endl;
	}
}
